/*****************************************************************************/
/*                      WiNRADiO G35DDC EXCALIBUR ULTRA                      */
/*                                SDK DEMO                                   */
/*                        (C) Copyright RADIXON 2017                         */
/*****************************************************************************/

#include "u_mainwindow.h"
#include "u_devicesetselector.h"
#include "u_defs.h"
#include "u_global.h"
#include <dlfcn.h>


class TApp: public wxApp
{
public:
    bool OnInit(void);
};

G35DDCAPI_CREATE_INSTANCE CreateInstance;

bool TApp::OnInit(void)
{
 TMainWindow *MainWindow;
 ICohG35DDCDeviceSet *DeviceSet;
 void *API;

    API=dlopen("libg35ddcapi.so",RTLD_LAZY);

    if(API==NULL)
    {
        wxMessageBox(wxT("Failed to load libg35ddcapi.so!"),APP_TITLE,wxICON_ERROR);
        return false;
    }

    CreateInstance=(G35DDCAPI_CREATE_INSTANCE)dlsym(API,"CreateInstance");

    if(CreateInstance==NULL)
    {
        wxMessageBox(wxT("Failed to load valid libg35ddcapi.so!"),APP_TITLE,wxICON_ERROR);
        dlclose(API);
        return false;
    }

    Global.Initialize();

    DeviceSet=TDeviceSetSelector::SelectDeviceSet();

    if(DeviceSet==NULL)
    {
        return false;
    }

    MainWindow=new TMainWindow(DeviceSet);

    MainWindow->Show(true);

    return true;
}

IMPLEMENT_APP(TApp)

